#include <gtk/gtk.h>
#include <string.h>
#include "attach.h"
#include "support.h"
#include "state.h"

typedef struct attach_struct {
	GtkWidget *widget;
	gchar *name[512];
}attach_st;


gboolean
on_enter_notify_event                  (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
	GdkCursor* cursor;
	cursor = gdk_cursor_new(GDK_HAND1);
	gdk_window_set_cursor(widget->window, cursor);
	gdk_cursor_destroy(cursor);
	
	return FALSE;
}

gboolean
on_leave_notify_event                  (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
	GdkCursor* cursor;
	cursor = gdk_cursor_new(0);
	gdk_window_set_cursor(widget->window, cursor);
	gdk_cursor_destroy(cursor);

	return FALSE;
}


gboolean
on_button_press_event			(GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
	GtkWidget *widget_button;
	gchar warning_msg[256] = "\0";
	attach_st *attach;

	attach = user_data;
	global_question.curnumattachs --;
	
	g_sprintf (warning_msg, _("Attached %d files from %d files"), global_question.curnumattachs, (global_question.numattachs + global_question.numscreens));
	impr_sql_attach_del (global_testplan.tpid, global_question.qnum, (gchar*)gtk_widget_get_name (widget));
	impr_sql_question_edit (global_question);

	widget_button = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));	
	gtk_widget_set_sensitive (widget_button, TRUE);	
	gtk_widget_set_tooltip_text (widget_button, warning_msg);

	widget_button = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));	
	gtk_widget_set_sensitive (widget_button, TRUE);		
	gtk_widget_set_tooltip_text (widget_button, warning_msg);

	widget_button = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));	
	gtk_widget_set_sensitive (widget_button, TRUE);		
	gtk_widget_set_tooltip_text (widget_button, warning_msg);

	gtk_widget_destroy (attach->widget);
	g_free (attach);
	return FALSE;
}


void
add_attach		(gint todb, gchar *filename)
{
	GtkWidget *hbox;
	GtkWidget *label_shortname;
	GtkWidget *label_delete;
	GtkWidget *label_hide_full_name;
	GtkWidget *event_box;
	GtkWidget *box_labels;
	gchar short_name[512];
	attach_st *attach;

	g_sprintf (short_name, "    %s", filename+search_last_slash(filename));
	if (short_name [strlen(short_name)-1] == '\n')
	{
		short_name [strlen(short_name)-1] = '\0';
	}

	if (todb)
	{
		impr_sql_attach_add (global_testplan.tpid, getuid (), global_question.qnum, filename);
		impr_sql_question_edit (global_question);
	}


	box_labels = GTK_WIDGET (get_widget ("vbox_labels"));
	hbox = gtk_hbox_new (FALSE, 5);
	gtk_box_pack_start (GTK_BOX (box_labels), hbox, FALSE, FALSE, 0);

	label_shortname = gtk_label_new (short_name);
	gtk_box_pack_start (GTK_BOX (hbox), label_shortname, FALSE, FALSE, 0);
	gtk_widget_show (label_shortname);

	label_hide_full_name = gtk_label_new (filename);

	gtk_box_pack_start (GTK_BOX (hbox), label_hide_full_name, FALSE, FALSE, 0);
	gtk_widget_set_no_show_all (label_hide_full_name, TRUE);
	
	event_box = gtk_event_box_new ();
	gtk_widget_set_name  (event_box, filename);
	gtk_box_pack_end (GTK_BOX (hbox), event_box, FALSE, FALSE, 0);

	attach = malloc (sizeof(attach_st));
	attach->widget = hbox;
	g_sprintf ((gchar*)attach->name, "%s", short_name);
	g_signal_connect (event_box, "button_press_event",G_CALLBACK (on_button_press_event), attach);
	g_signal_connect (event_box, "enter_notify_event",G_CALLBACK (on_enter_notify_event), attach);
	g_signal_connect (event_box, "leave_notify_event",G_CALLBACK (on_leave_notify_event), attach);

	label_delete = gtk_label_new ("");
	gtk_label_set_markup (GTK_LABEL (label_delete), _("<span fgcolor=\"#0000FF\" underline=\"single\">delete</span>"));
	gtk_container_add (GTK_CONTAINER (event_box), label_delete);


	gtk_widget_show_all (hbox);
	gtk_widget_show_all (box_labels);
	gtk_widget_hide (label_hide_full_name);
	gtk_widget_show_all (hbox);
//	g_free (attach);
}


static void
for_each_hbox_destroy 		(GtkWidget *child,
				 gpointer   client_data)
{
	gtk_widget_destroy (child);
}


void
destroy_attach_widgets		 ()
{
	GtkWidget *widget;
	GtkWidget *box_labels;

	box_labels = GTK_WIDGET (gtk_builder_get_object (builder, "vbox_labels"));

	gtk_container_forall (GTK_CONTAINER (box_labels),for_each_hbox_destroy, NULL);

	attach_num = 0;
}




