#include <gtk/gtk.h>
#include <glib-object.h>

#include "state.h"
#include "support.h"
#include "pthreads.h"
#include "attach.h"
#include "testmap.h"

G_MODULE_EXPORT void
on_window1_destroy                	(GtkObject       *object,
                                        gpointer         user_data)

{
	command_close_connection (global_sockfd);

	if (current_state > 3 && current_state <= 7) 
	{
		impr_sql_testplans_update_status_to_dowbload ();
		impr_sql_testplan_update (global_testplan);
		impr_sql_question_edit (global_question);
		impr_sql_testplan_update_wish (global_testplan);
	}


	if (current_state == STATE_TEST)
	{
		request_update_question ();
		impr_sql_testplan_update (global_testplan);
	}

	if (current_state == STATE_END)	
	{
		impr_sql_testplans_update_status_to_dowbload ();
	}


	gtk_main_quit();
}


G_MODULE_EXPORT void
on_button_finish_clicked               (GtkObject       *object,
                                      gpointer         user_data)
{
	command_close_connection (global_sockfd);

	if (current_state != STATE_END)
	{
		impr_sql_testplan_update (global_testplan);
		impr_sql_question_edit (global_question);
	}
	else
	{
		impr_sql_testplans_update_status_to_dowbload ();
		impr_sql_testplan_update_wish (global_testplan);
		gtk_main_quit ();
	}

	if (current_state == STATE_TEST)
	{
		if (map_status)
		{
			gtk_widget_destroy (lookup_widget (GET_WIDGET ("window1"), "window_testmap"));
			map_status = 0;
		}
		request_update_question ();
		impr_sql_testplan_update (global_testplan);
		impr_sql_testplan_update_status (global_testplan, "FINISHED");
		impr_sql_testplan_edit_finish_time (global_testplan.tpid, global_testplan.uid);
		set_state_addon ();
	}
	else
	{
		impr_sql_testplan_update_wish (global_testplan);
		impr_sql_testplans_update_status_to_dowbload ();
		request_update_question ();
		gtk_main_quit ();
	}
}


G_MODULE_EXPORT void
on_button_full_testplan_list_clicked (GtkObject       *object,
                                      gpointer         user_data)
{
	
	if (current_state == STATE_REGOK)
	{
		get_news ();
	}
	else
	{
		fill_tree (GTS_testplan);
	}

	if (current_state == STATE_TEST)
	{
		request_update_question ();
		impr_sql_testplan_update (global_testplan);
	}
	set_state_testplanlist ();
}


G_MODULE_EXPORT void
on_button_next_clicked			(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner;

	if (current_state == STATE_REGNO)
	{
		spinner = SpinnerWindow (_("Please wait. Registration is in proccess"));
		g_thread_create (pthread_registration, spinner, FALSE, NULL);
	}

	if (current_state == STATE_REGOK)
	{
		spinner = SpinnerWindow ( _("Loading updates for test plans"));
		g_thread_create (pthread_reload, spinner, FALSE, NULL);
	}

	if (current_state == STATE_TEST)
	{
		request_update_question ();
		global_testplan.curquestion ++;
		
		set_state_test ();
	}

	if (current_state == STATE_TESTDESCR)
	{
		impr_sql_testplan_update_status (global_testplan, "STARTED");
		impr_sql_testplan_edit_start_time (global_testplan.tpid, global_testplan.uid);
		set_state_test ();
	}

	if (current_state == STATE_ADDON)
	{
		impr_sql_testplan_update_wish (global_testplan);
		set_state_send ();
	}
}

G_MODULE_EXPORT void
on_button_prev_clicked			(GtkObject       *object,
                                        gpointer         user_data)
{
	if (current_state == STATE_ADDON)
	{
		impr_sql_testplan_update_wish (global_testplan);
	}

	if (current_state != STATE_ADDON && current_state != STATE_SEND)
	{
		request_update_question ();
		global_testplan.curquestion --;
	}

	if (current_state == STATE_SEND)
	{
		set_state_addon ();
	}
	else
	{
		set_state_test ();
	}


}

G_MODULE_EXPORT void
on_entry_name_changed			(GtkObject       *object,
                                        gpointer         user_data)
{
	check_reg_form ();
}


G_MODULE_EXPORT void
on_entry_fam_changed			(GtkObject       *object,
                                        gpointer         user_data)
{
	check_reg_form ();
}


G_MODULE_EXPORT void
on_entry_mail_changed			(GtkObject       *object,
                                        gpointer         user_data)
{
	check_reg_form ();
}


G_MODULE_EXPORT void
on_entry_comment_changed		(GtkObject       *object,
                                        gpointer         user_data)
{
	check_reg_form ();
}


G_MODULE_EXPORT void
on_treeview_testplanlist_cursor_changed (GtkTreeView *tree_view,
                                           gpointer     user_data)  
{
	GtkTreeIter iter;
	GtkTreeSelection *selection = gtk_tree_view_get_selection (tree_view);
	gint isgroup;
	gint tpid;

	if (gtk_tree_selection_get_selected (selection, NULL, &iter))
	{
		gtk_tree_model_get(GTK_TREE_MODEL (GTS_testplan), &iter, 2, &isgroup, 4, &tpid, -1);
		if (!isgroup)
		{
			gtk_widget_set_sensitive (get_widget ("button_start"), TRUE);
			gtk_widget_set_sensitive (get_widget ("button_map"), TRUE);

			if (map_status)
			{
				gtk_list_store_clear (GLS_map);
				impr_sql_question_get_list (tpid, getuid (), add_question_list, NULL);
			}
		}
		else
		{
			gtk_widget_set_sensitive (get_widget ("button_start"), FALSE);
			gtk_widget_set_sensitive (get_widget ("button_map"), FALSE);
		}
	}	
}


G_MODULE_EXPORT void
on_button_start_clicked	(GtkObject       *object,
                         gpointer         user_data)
{
	GtkTreeIter iter;
	GtkTreeSelection *selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (get_widget ("treeview_testplanlist")));
	gint tpid;
	gint cur_question;
	gchar *status;

	if (gtk_tree_selection_get_selected (selection, NULL, &iter))
	{
		gtk_tree_model_get(GTK_TREE_MODEL (GTS_testplan), &iter, 3, &status, 4, &tpid, -1);

		impr_sql_testplan_init_struct (tpid, &global_testplan);
		set_state_testdescr ();
		g_free (status);		
	}

}

G_MODULE_EXPORT void
on_togglebutton_started_testplans_toggled (GtkObject       *object,
		                           gpointer         user_data)
{
	if (gtk_toggle_button_get_active  (GTK_TOGGLE_BUTTON (object)))
	{
		gtk_widget_show_all (GET_WIDGET ("vbox_started_list"));
	}
	else
	{
		gtk_widget_hide (GET_WIDGET ("vbox_started_list"));
	}
}



gint
check_buffer (GtkTextBuffer* buffer)
{
	GtkTextIter iter_start, iter_end;
	gchar *text = NULL;
	GtkWidget *widget;
	GdkColor color;
	color.red = 65535;
	color.green = 26774;
	color.blue = 29601;

	gtk_text_buffer_get_start_iter (buffer, &iter_start);
	gtk_text_buffer_get_end_iter  (buffer, &iter_end);

	text = gtk_text_buffer_get_text (GTK_TEXT_BUFFER (buffer), &iter_start, &iter_end, 0);

	if (strlen (text) > 8192)
	{
		widget = GTK_WIDGET (get_widget ("textview_comment"));
		gtk_widget_modify_text (widget, GTK_STATE_NORMAL, &color);
	}
	else
	{
		gdk_color_parse ("black", &color);
		widget = GTK_WIDGET (get_widget ("textview_comment"));
		gtk_widget_modify_text (widget, GTK_STATE_NORMAL, &color);
	}

	if (strlen (text) == 0)
	{
		return 0;
	}

	g_free (text);
	return 1;
}


void                
on_textbuffer1_changed			(GtkTextBuffer *buffer,
                      		   	gpointer       user_data)
{
	GtkTextIter iter_start, iter_end;
	gchar *text = NULL;	

	check_buffer (buffer);
	
	gtk_text_buffer_get_start_iter (buffer, &iter_start);
	gtk_text_buffer_get_end_iter  (buffer, &iter_end);

	text = gtk_text_buffer_get_text (GTK_TEXT_BUFFER (buffer), &iter_start, &iter_end, 0);

	if (strlen (text) > 8192)
	{
		g_strlcpy (global_question.comment, text, 8190);
		global_question.comment [8191] = '\0';
	}
	else
	{
		g_sprintf (global_question.comment, "%s", text);
	}
	
	g_free (text);
}


G_MODULE_EXPORT void
on_button_attach_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	time_t result;
	gchar filename[256] = "/0", time_str[128], warning_msg[256]="\0";
	GdkPixbuf *screenshot;
	GtkWidget *window, *widget;

	window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
	gtk_window_iconify (GTK_WINDOW (window));
	screenshot = get_screenshot ();
	gtk_window_deiconify (GTK_WINDOW (window));
	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_sprintf (filename, "%s/%s/screenshots/%d_%s.jpeg", g_get_home_dir (), CACHE_DIR, global_question.curnumattachs ++, time_str);

	add_attach (1, filename);
	gdk_pixbuf_save (screenshot, filename, "jpeg", NULL,  "quality", "100", NULL);

	if (global_question.curnumattachs == (global_question.numattachs + global_question.numscreens))
	{
		g_sprintf (warning_msg, _("Limit of attached files is reached"));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);
	}
	else
	{
		g_sprintf (warning_msg, _("Attached %d files from %d files"), global_question.curnumattachs, (global_question.numattachs + global_question.numscreens));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
	}

}


G_MODULE_EXPORT void
on_button_attach_pause_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner_window;
	gchar text[256];

	g_sprintf (text, _("Waiting for screenshot %d seconds"), user_info.pause);

	spinner_window = SpinnerWindow (text);
	g_thread_create (pthread_attach_pause, spinner_window, FALSE, NULL);
}


gint
check_file_size (gchar *filename)
{
	struct stat buf;

	choppy (filename, '\0');
	if (g_stat (filename, &buf) == -1)
	{
		return -1;
	}
	if (buf.st_size > 10240000)
	{
		return -1;
	}

	return 0;
}

//void
#if 0

#endif

GtkWidget *
CreateFileChooser (gchar *text_header, gchar *text_error)
{
        GtkWidget *dialog, *widget;
        GtkResponseType response;
        gchar *filename_from_dialog = NULL;
	gchar filename[512] = "\0", warning_msg[256]="\0";

        dialog = gtk_file_chooser_dialog_new(_("Attach file"),
    						GTK_WINDOW (gtk_builder_get_object (builder, "window1")),
    						GTK_FILE_CHOOSER_ACTION_OPEN,
    						GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_ADD,
    						GTK_RESPONSE_OK,
    						NULL);
//        gtk_widget_show (dialog);

        return dialog;
}

G_MODULE_EXPORT void
on_button_attach_any_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
        GtkWidget *dialog, *widget;
        GtkResponseType response;
        gchar *filename_from_dialog = NULL;
	gchar filename[512] = "\0", warning_msg[256]="\0";


run_dialog:
	gtk_widget_show (FCD_widget);
        response = (GtkResponseType)gtk_dialog_run (GTK_DIALOG (FCD_widget));

        if (response == GTK_RESPONSE_OK)
        {
    		filename_from_dialog = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (FCD_widget));
    		if (check_file_size (filename_from_dialog) == -1)
    		{
    			error_dialog (_("File can not be more then 10 Mb"), GTK_MESSAGE_ERROR);
    			goto run_dialog;
    		}
    		global_question.curnumattachs  ++;

		if (global_question.curnumattachs == (global_question.numattachs + global_question.numscreens))
		{
			g_sprintf (warning_msg, _("Limit of attached files is reached"));
			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));
			gtk_widget_set_sensitive (widget, FALSE);
			gtk_widget_set_tooltip_text (widget, warning_msg);

			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));
			gtk_widget_set_sensitive (widget, FALSE);
			gtk_widget_set_tooltip_text (widget, warning_msg);

			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));
			gtk_widget_set_sensitive (widget, FALSE);
			gtk_widget_set_tooltip_text (widget, warning_msg);
		}
		else
		{
			g_sprintf (warning_msg, _("Attached %d files from %d files"), global_question.curnumattachs, (global_question.numattachs + global_question.numscreens));
			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));

			gtk_widget_set_tooltip_text (widget, warning_msg);
			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));

			gtk_widget_set_tooltip_text (widget, warning_msg);
			widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));

			gtk_widget_set_tooltip_text (widget, warning_msg);
		}

		add_attach (1, filename_from_dialog);
    		g_free (filename_from_dialog);
        }
        gtk_widget_hide (FCD_widget);
}


G_MODULE_EXPORT void
on_button_map_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *map;
	GtkTreeIter iter;
	GtkTreeSelection *selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (get_widget ("treeview_testplanlist")));
	gint tpid;


	if (gtk_tree_selection_get_selected (selection, NULL, &iter))
	{

		gtk_tree_model_get(GTK_TREE_MODEL (GTS_testplan), &iter, 4, &tpid, -1);
		if (!map_status)
		{
			map = CreateTestMap (0, tpid);
			gtk_widget_show (map);
		}
	}
}


G_MODULE_EXPORT void
on_button_test_map_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *map;
	if (!map_status)
	{
		request_update_question ();
		map = CreateTestMap (0, global_testplan.tpid);
		gtk_widget_show (map);
	}
}


G_MODULE_EXPORT void
on_togglebutton1_toggled		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *dialog, *widget;
        GtkResponseType response;
        gchar *filename_from_dialog = NULL;
	gchar filename[512] = "\0", warning_msg[256]="\0";

	if (current_state == STATE_ADDON)
	{
		if (!gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (object)))
		{
			gtk_entry_set_text (GTK_ENTRY (get_widget ("entry_wish_name")), "");
			bzero (global_testplan.wish_file, 512);
		}
		else
		{
			dialog = gtk_file_chooser_dialog_new(_("Attach file"), 
								GTK_WINDOW (gtk_builder_get_object (builder, "window1")), 
								GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_ADD, 
								GTK_RESPONSE_OK, 
								NULL);
			gtk_widget_show (dialog);
		run_dialog:
			response = (GtkResponseType)gtk_dialog_run (GTK_DIALOG (dialog));

			if (response ==  GTK_RESPONSE_OK)
			{
		    		filename_from_dialog = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		    		if (check_file_size (filename_from_dialog) == -1)
		    		{
		    			error_dialog (_("File can not be more then 10 Mb"), GTK_MESSAGE_ERROR);
		    			goto run_dialog;
		    		}

				gtk_entry_set_text (GTK_ENTRY (get_widget ("entry_wish_name")), filename_from_dialog);
				g_sprintf (global_testplan.wish_file, "%s", filename_from_dialog);
		    		g_free (filename_from_dialog);
			}
			gtk_widget_destroy (dialog);
		}
	}
}


void
on_textbuffer2_changed			(GtkTextBuffer *buffer,
                      		   	gpointer       user_data)
{
	GtkTextIter iter_start, iter_end;
	gchar *text = NULL;	

	check_buffer (buffer);
	
	gtk_text_buffer_get_start_iter (buffer, &iter_start);
	gtk_text_buffer_get_end_iter  (buffer, &iter_end);

	text = gtk_text_buffer_get_text (GTK_TEXT_BUFFER (buffer), &iter_start, &iter_end, 0);

	if (strlen (text) > 8192)
	{
		g_strlcpy (global_testplan.wish_text, text, 8190);
		global_question.comment [8191] = '\0';
	}
	else
	{
		g_sprintf (global_testplan.wish_text, "%s", text);
	}
	
	g_free (text);
}


G_MODULE_EXPORT void
on_button_send_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner_window;
	gchar text[256];

	spinner_window = SpinnerWindow (_("Generating report and send"));
	g_thread_create (pthread_send, spinner_window, FALSE, NULL);
}


void
LoadPlan	()
{
        GtkWidget *dialog, *spinner;
        GtkResponseType response;
        gchar *filename_from_dialog = NULL;
	gchar warning_msg[256]="\0";
	pthread_data_st *user_data;



        dialog = gtk_file_chooser_dialog_new(_("Import test plan"), GTK_WINDOW (gtk_builder_get_object (builder, "window1")), GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_ADD, GTK_RESPONSE_OK, NULL);
        gtk_widget_show (dialog);
run_dialog:
        response = (GtkResponseType)gtk_dialog_run (GTK_DIALOG (dialog));

        if (response ==  GTK_RESPONSE_OK)
        {
    		filename_from_dialog = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		gtk_widget_destroy (dialog);
		spinner = SpinnerWindow (_("Please wait. Adding test plan"));
		user_data = malloc (sizeof (pthread_data_st));
		user_data->widget = spinner;
		g_sprintf (user_data->text, "%s", filename_from_dialog);

		g_thread_create (pthread_import_plan, user_data, FALSE, NULL);
   		g_free (filename_from_dialog);
        }
	else
	{
	        gtk_widget_destroy (dialog);
	}

}


G_MODULE_EXPORT void
on_button_localload_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner_window;
	gchar text[256];

	LoadPlan ();
}


G_MODULE_EXPORT void
on_button_reload_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner_window;
	gchar text[256];

	g_sprintf (text, _("Loading updates for test plans"));

	spinner_window = SpinnerWindow (text);
	g_thread_create (pthread_reload, spinner_window, FALSE, NULL);
}


G_MODULE_EXPORT void
on_button_send_reports_clicked		(GtkObject       *object,
                                        gpointer         user_data)
{
	GtkWidget *spinner_window;
	gchar text[256];

	spinner_window = SpinnerWindow (_("Sending reports"));
	g_thread_create (pthread_send_reports, spinner_window, FALSE, NULL);
}


G_MODULE_EXPORT void
on_treeview_testplanlist_row_activated (GtkTreeView        *treeview,
		                       GtkTreePath        *path,
                		       GtkTreeViewColumn  *col,
		                       gpointer            userdata)
{
	GtkTreeIter iter;
	GtkTreeSelection *selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (get_widget ("treeview_testplanlist")));
	gint tpid;
	gint cur_question, isgroup;
	gchar *status;

	if (gtk_tree_selection_get_selected (selection, NULL, &iter))
	{
		gtk_tree_model_get(GTK_TREE_MODEL (GTS_testplan), &iter, 2, &isgroup, 3, &status, 4, &tpid, -1);

		if (!isgroup)
		{
			impr_sql_testplan_init_struct (tpid, &global_testplan);
			set_state_testdescr ();
		}
		g_free (status);
	}
}


G_MODULE_EXPORT gboolean 
on_window1_key_press_event (GObject *obj, GdkEventKey *key, gpointer data)
{
	GtkWidget *widget = NULL;


//	printf ("%d %d\n", key->state, key->keyval);
        if (current_state == STATE_TEST)
        {
		if (global_question.isown)
		{
			if (key->state == 24 || key->state == 8216 || key->state == 8 || key->state == 8200)
			{
				if (key->keyval == 113 || key->keyval == 1738)
				{
//                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (get_widget ("window1"), "check_own_button")), TRUE);
                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lookup_widget (get_widget ("window1"), "check_own_button")), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (lookup_widget (get_widget ("window1"), "check_own_button"))));
				}
			}
		}

//		printf ("%s\n", global_question.type);
		if (g_strcmp0 (global_question.type, "single") == 0)
		{

			if (key->state == 24 || key->state == 8216 || key->state == 8 || key->state == 8200)
			{
				switch (key->keyval)
				{
					case 49: // 1
						widget = lookup_widget (get_widget ("window1"), "radio0");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 50: // 2
						widget = lookup_widget (get_widget ("window1"), "radio1");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 51: // 3
						widget = lookup_widget (get_widget ("window1"), "radio2");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 52: // 4
						widget = lookup_widget (get_widget ("window1"), "radio3");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 53: // 5
						widget = lookup_widget (get_widget ("window1"), "radio4");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 54: // 6
						widget = lookup_widget (get_widget ("window1"), "radio5");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 55: // 7
						widget = lookup_widget (get_widget ("window1"), "radio6");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 56: // 8
						widget = lookup_widget (get_widget ("window1"), "radio7");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
					case 57: // 9
						widget = lookup_widget (get_widget ("window1"), "radio8");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
						}
					break;
				}
			}
		}
		else
		{
			if (key->state == 24 || key->state == 8216 || key->state == 8 || key->state == 8200)
			{
				switch (key->keyval)
				{
					case 49: // 1
						widget = lookup_widget (get_widget ("window1"), "check0");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 50: // 2
						widget = lookup_widget (get_widget ("window1"), "check1");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 51: // 3
						widget = lookup_widget (get_widget ("window1"), "check2");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 52: // 4
						widget = lookup_widget (get_widget ("window1"), "check3");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 53: // 5
						widget = lookup_widget (get_widget ("window1"), "check4");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 54: // 6
						widget = lookup_widget (get_widget ("window1"), "check5");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 55: // 7
						widget = lookup_widget (get_widget ("window1"), "check6");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 56: // 8
						widget = lookup_widget (get_widget ("window1"), "check7");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
					case 57: // 9
						widget = lookup_widget (get_widget ("window1"), "check8");
						if (widget != NULL)
						{
		                                        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), !gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)));
						}
					break;
				}
			}
		}
        }
        return FALSE;
}

