#include <netinet/in.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <stdarg.h>

#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>


#ifndef __R_TRANS_H
#include "rtrans.h"
#endif

#include "support.h"

//int IS_LOG_DEBUG = 2;  //LOG_FILE;
int IS_LOG_DEBUG = 1;  //STDOUT
FILE *error_log = NULL;



int 
init_server_struct (char *fileconfig, 
		    char *fileprotocol,
		    char *fileversion,
		    server_st *server_info)
{
	FILE *f;
	int rc;
	ssize_t read_st;
        size_t len = 0;
        char *line = NULL;
	char buf[256], DEV_NULL[1024] = "\0";

//	sprintf (filename,"%s/%s/improver_client.conf", g_get_home_dir (), CACHE_DIR);

	f = fopen (fileconfig, "r");		
	if (!f)
	{
		printf ("Error: cant open config file %s\n", fileconfig);
		exit (1);
	}

	while ((read_st = getline(&line, &len, f)) != -1) 
	{
/*		if (strstr (line, "SCREENSHOT_PAUSE_TIME: "))
		{
			time_pause = atoi (line + 23);
			if (time_pause > 10)
			{
				time_pause = 10;
			}
		}
*/
		if (strstr (line, "SERVER: "))
		{
			bzero (buf, 256);
			sprintf (buf, "%s", line+8);
			choppy (buf, '\0');
			sprintf (server_info->servername, "%s", buf);

		}

		if (strstr (line, "PORT: "))
		{
			bzero (buf, 256);
			sprintf (buf, "%s", line+6);
			choppy (buf, '\0');
			sprintf (server_info->port, "%s", buf);
		}
	}

	fclose (f);
	

	f = fopen (fileprotocol, "r");		
	if (!f)
	{
		printf ("Error: cant open config file %s\n", fileprotocol);
		exit (1);
	}

	rc = fscanf (f, "%s %s", DEV_NULL, server_info->protocol_version);
	fclose (f);

	f = fopen (fileversion, "r");		
	if (!f)
	{
		printf ("Error: cant open config file %s\n", fileversion);
		exit (1);
	}

	rc = fscanf (f, "%s %s", DEV_NULL,  server_info->client_version);
	fclose (f);

	free (line);
	
	
}

int
connect_server (server_st server_info)
{
    int sockfd, portno, n;
    struct sockaddr_in serv_addr;
    struct hostent *server;
    char buf[20] = "\0";
    struct timeval tv = { 30, 0 };

    portno = atoi(server_info.port);
    sockfd = socket(AF_INET, SOCK_STREAM, 0);

    if (sockfd < 0) 
    {
        return -EXIT_FAILURE;
    }

    server = gethostbyname(server_info.servername);
    if (server == NULL) 
    {
        fprintf(stderr,"ERROR, no such host\n");
        return -EXIT_FAILURE;
    }

    bzero ((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy ((char *) server->h_addr, (char *)&serv_addr.sin_addr.s_addr,
        server->h_length);

    serv_addr.sin_port = htons(portno);

    if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
    {
        return -EXIT_FAILURE;
    }

    send_sec (sockfd, server_info.protocol_version,     strlen (server_info.protocol_version));
    send_sec (sockfd, server_info.client_version,     strlen (server_info.client_version));

    recv_sec (sockfd, buf);

    if (strcmp (buf, "FAILED") == 0)
    {
	    return -EXIT_FAILURE;
    }
    return sockfd;
}

//#define DEMO 0
#define DEMO 1

int
command_find (int sockfd, const char *hw_id, const char *locale, \
   char *first_name, char *second_name, char *email)
{
    char buffer[16] = "\0";
    char filename[256];
    char locale_new[256] = "\0";
    char buffer2[256] = "\0";
    int i = 0;

    while (locale[i] != '.')
    {
	buffer2[i] = locale[i];
	i ++;
    }
    
    buffer2 [i+1] = '\0';

    sprintf (locale_new, "%s.utf8", buffer2);

    send_sec (sockfd, "FIND", 4);
    send_sec (sockfd, (char*)hw_id, strlen (hw_id));

    send_sec (sockfd, (char*)locale_new, strlen (locale_new));

    recv_sec (sockfd, buffer);
    if (strcmp (buffer, "SUCCESS") != 0)
    {
	if (strcmp (buffer, "DBFAILED") == 0)
	{
		return -2;
	}
	else
	{
    		return -EXIT_FAILURE;
    	}
    }
    recv_sec (sockfd, first_name);
    recv_sec (sockfd, second_name);
    recv_sec (sockfd, email);

    return EXIT_SUCCESS;
}


int 
command_registr (int sockfd, char* path, char *first_name, char *second_name, \
    char *email, char *hw_id, char *locale, char *comment)
{
    char buffer[9] = "\0";
    char filename[256], buffer2[256] = "\0";
    char locale_new[256] = "\0";
    int i = 0;


//    printf ("LOCALE: %s %s\n", locale, getenv ("LANG"));
    send_sec (sockfd, "REGISTR", 7);

    send_sec (sockfd, first_name, strlen (first_name));

    send_sec (sockfd, second_name, strlen (second_name));
    send_sec (sockfd, email, strlen (email));
    send_sec (sockfd, hw_id, strlen (hw_id));
    
    while (locale[i] != '.')
    {
	buffer2[i] = locale[i];
	i ++;
    }
    
    buffer2 [i+1] = '\0';

    sprintf (locale_new, "%s.utf8", buffer2);

    send_sec (sockfd, locale_new, strlen (locale_new));
    send_sec (sockfd, comment, strlen (comment));

    sprintf (filename, "%s", path);
    send_file (sockfd, filename);
    recv_sec (sockfd, buffer);

    if (strcmp (buffer, "SUCCESS") != 0)
    {
        return -EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}




int
command_get_testplan (int sockfd, char *path)
{
    char command[512] = "\0", filename[512] = "\0", status[8] = "\0";
    int flag = 1;

    send_sec (sockfd, "TESTPLAN", 8);

    while (flag == 1)
    {
	bzero (command, 512);
        recv_sec (sockfd, command);

        if (strcmp (command, "END") && strcmp (command, "FAILED"))
        {
    	    bzero (filename, 512);
//    	    recv_sec (sockfd, status);
            sprintf (filename, "%s/%s", path, command);
            recv_file (sockfd, filename);
            send_sec (sockfd, command, strlen (command));
        }
        else
        {
        	flag = 0;
        }
    };

    return EXIT_SUCCESS;
}

int
command_close_connection (int sockfd)
{
    send_sec (sockfd, "CLOSE_CLIENT", 12);
    shutdown (sockfd, SHUT_RDWR);
    close (sockfd);
    return EXIT_SUCCESS;
}

int
command_end_operation (int sockfd)
{
    send_sec (sockfd, "END", 3);
    return EXIT_SUCCESS;
}

int
command_send_file (int sockfd, char *path, char *filename, char* type)
{
    char fullpath[512], buffer[512] = "\0";
    struct stat buf;    	

    bzero (fullpath, sizeof(fullpath));
    sprintf (fullpath, "%s/%s", path, filename);

    if (strcmp (type, "REPORT") == 0)
    {
        send_sec (sockfd, "REPORT", 6);
    }
    else
    {
	if (stat (fullpath, &buf) != -1)
	{
        	if (strcmp (type, "ATTACH") == 0)
		{
           		send_sec (sockfd, "ATTACH", 6);
		}
		else
		{
    	    		return -EXIT_FAILURE;
		}
	}
	else
	{
		goto end_attach;
	}
    }

    send_sec (sockfd, filename, strlen (filename));
    send_file (sockfd, fullpath);
    recv_sec (sockfd, buffer);
//    puts (buffer);
    if (strcmp (buffer, "SUCCESS") != 0)
    {
       	return -EXIT_FAILURE;
    }
end_attach:
    return EXIT_SUCCESS;
}

int
command_send_attach (int sockfd, char *path, char *filename)
{
    return command_send_file (sockfd, path, filename, "ATTACH");
}

int
command_send_report (int sockfd, char *path, char *filename)
{
//	printf ("SEND REPORT: [%s] [%s]\n", path, filename);
    return command_send_file (sockfd, path, filename, "REPORT");
}


