/*
main.c 
pthreads.c pthreads.h 			- all pthreads are there. 
xml_work.c xml_work.h 			- work with xml files: reading testplans, generate reports.
improver_sqlite.c improver_sqlite.h	- work with sqlite3 data  base. all request are there.
callbacks.c callbacks.h 		- all callbacks from .glade file, and some support functions.
client.c client.h 			- protocol
rtrans.c				- "low-level" socks-interface
hw_parser.c hw_parser.h			- parsing hw_info in xml
log.c log.h 				- log funtion
testmap.c testplap.h			- work with test-map window (questions list etc)
testplan_treeview.c testplan_treeview.h - work with testplans list (filling, rendering)
regform.c regform.h			- work with register form
request_from_gui*			- some crap :\
state.c state.h				- create states for gui (hide/show needed widgets), create question form (single-radio, multi-check)
own_callbacks.c own_callbacks.h		- callbacks from own widgets (testmap, radio/check buttons)
attach.c attach.h 			- create attachs labels

Writed by Leontiev Danila
*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include <time.h>
#include <linux/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>       
#include "support.h"
#include "pthreads.h"
#include "callbacks.h"
#include "own_callbacks.h"
#include "state.h"
//#include "client.h"
//#include "improver_sqlite.h"

GtkWidget 
*splash ()
{
	GtkWidget *splash;
	GtkWidget *imgbox;
	GtkWidget *image;
	GtkWidget *event;
		
	/* Splash window */
	splash = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_icon_from_file  (GTK_WINDOW (splash), "/usr/share/improver_client/pixmaps/improver_client.png", NULL);


	/* Not managed window */
	gtk_window_set_decorated (GTK_WINDOW (splash), FALSE);
	gtk_window_set_position(GTK_WINDOW(splash), GTK_WIN_POS_CENTER);
	
	/* Image container box */
	event = gtk_event_box_new ();
	g_signal_connect (event, "enter_notify_event",G_CALLBACK (on_enter_splash_notify_event), NULL);
	g_signal_connect (event, "leave_notify_event",G_CALLBACK (on_leave_splash_notify_event), NULL);

	gtk_container_add (GTK_CONTAINER (splash), event);
	
	imgbox = gtk_hbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (event), imgbox);
	
	/* Image */
	image = gtk_image_new_from_file ("/usr/share/improver_client/pixmaps/improver_client_splash.png");
	gtk_box_pack_start (GTK_BOX (imgbox), image, FALSE, FALSE, 0);
	

	gtk_widget_show_all (splash);
	return splash;
}


int
main	(int argc, 
	 char *argv[])
{
	GtkListStore *question_list_var;
	gchar text[256] = "\0", name[32] = "\0", config[128] = "\0";
	GtkWidget *splash_widget, *window;

	gint i;

	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);

	db = NULL;
	global_sockfd = 0;

	check_dirs ();

	g_sprintf (config, "%s/%s/improver_client.conf",g_get_home_dir (), CACHE_DIR);
	init_server_struct (config, PROTOCOLS_VERSION, CLIENT_VERSION, &server_info);

	g_sprintf (config, "%s/%s/bd",g_get_home_dir (), CACHE_DIR);
  	impr_sql_init (config, &db);

	map_status = 0;
	server_status = 0;

	gtk_init (&argc, &argv);

	g_thread_init(NULL);
	gdk_threads_init();

	builder = gtk_builder_new ();
        gtk_builder_add_from_file (builder, "/usr/share/improver_client/improver_client.glade", NULL);
	gtk_builder_connect_signals (builder, NULL);

	splash_widget = splash ();
	FCD_widget = CreateFileChooser (_("Attach any"), "");

	g_thread_create (pthread_gethwinfo, splash_widget, FALSE, NULL);
	gtk_main ();
	return 0;
}


