#include <gtk/gtk.h>
#include <glib-object.h>

#include "state.h"
#include "support.h"
#include "testmap.h"


gint
check_own_form (gint for_request, gchar *out)
{
	gint i, type_i;
	gint res = 0;
	gchar radio_name[32] = "\0";
	gchar answer[1024] = "\0", type[8] = "\0";
	GtkWidget *widget = NULL;

	if (! g_strcmp0 (global_question.type, "single"))
	{
		type_i = 1;
		g_sprintf (type, "radio");
	}
	else
	{
		type_i = 10;
		g_sprintf (type, "check");
	}

	for (i = 0; i < global_question.numanswers-global_question.isown; i++)
	{
		g_sprintf (radio_name, "%s%d", type, i);
		if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (lookup_widget (get_widget ("window1"), radio_name))))
		{
			if (type_i == 1)
			{
				if (global_question.isown)
				{
					gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
				}
			}

			if (for_request)
			{
				g_sprintf (out, "%s", gtk_button_get_label (GTK_BUTTON (lookup_widget (get_widget ("window1"), radio_name))));
			}
			res = 1;
		}
	}

	if (global_question.isown)
	{
		widget = lookup_widget (get_widget ("window1"), "check_own_button");
		if (widget != NULL)
		{
			if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
			{
				gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), TRUE);
				g_sprintf (answer, "%s", gtk_entry_get_text (GTK_ENTRY (lookup_widget (get_widget ("window1"),  "check_own_entry"))));
				if (strlen (answer) > 0)
				{
					if (for_request)
					{
						g_sprintf (out, "%s", answer);
					}
					return 2;
				}
				else
				{
					gtk_widget_set_sensitive (get_widget ("textview_comment"), TRUE);
				}
			}
			else
			{
				if (type_i == 10)
				{
					gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
				}
			}
		}
	}
	return res;
}


void
on_radio_check_clicked			(GtkObject       *object,
                                        gpointer         user_data)
{
	gint res;
	res = check_own_form (0, NULL);

	if (res)
	{
		if (!global_question.answered)
		{
			global_testplan.questionnumdone ++;
			global_question.answered = 1;
			gtk_tree_model_foreach   (GTK_TREE_MODEL (GLS_map),  edit_map_tree , NULL);
			gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/green.png");
		}
		gtk_widget_set_sensitive (get_widget ("textview_comment"), TRUE);
	}
	else
	{
		if (global_question.answered)
		{
			global_question.answered = 0;
			global_testplan.questionnumdone --;
			gtk_tree_model_foreach   (GTK_TREE_MODEL (GLS_map),  edit_map_tree , NULL);
			gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/red.png");	
		}
	}

	if (global_testplan.questionnumdone == global_testplan.questionnum)
	{
		gtk_widget_set_sensitive (get_widget ("button_finish"), TRUE);
	}
	else
	{	
		gtk_widget_set_sensitive (get_widget ("button_finish"), FALSE);
	}
	
	impr_sql_testplan_update (global_testplan);
	request_update_question ();
}


void
on_entry_ownanswer_changed		(GtkObject       *object,
                                        gpointer         user_data)
{
	gchar answer[1024] = "\0";

	g_sprintf (answer, "%s",gtk_entry_get_text (GTK_ENTRY (lookup_widget (get_widget ("window1"), "check_own_entry"))));
	if (!g_strcmp0 (global_question.type, "single"))
	{
answered:
		if (strlen (answer) == 0)
		{
			if (global_question.answered)
			{
				global_question.answered = 0;
				global_testplan.questionnumdone --;			
				gtk_tree_model_foreach   (GTK_TREE_MODEL (GLS_map),  edit_map_tree , NULL);
				gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/red.png");
			}
		}
		else
		{
			if (!global_question.answered)
			{
				global_question.answered = 1;
				global_testplan.questionnumdone ++;
				gtk_tree_model_foreach   (GTK_TREE_MODEL (GLS_map),  edit_map_tree , NULL);
				gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/green.png");
			}
		}
	}
	else
	{
		if (check_own_form (0, NULL) != 1)
		{
			goto answered;
		}
	}

	if (global_testplan.questionnumdone == global_testplan.questionnum)
	{
		gtk_widget_set_sensitive (get_widget ("button_finish"), TRUE);
	}
	else
	{	
		gtk_widget_set_sensitive (get_widget ("button_finish"), FALSE);
	}
	
	impr_sql_testplan_update (global_testplan);
	request_update_question ();
}


gboolean
on_enter_splash_notify_event           (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
        GdkCursor* cursor;
        cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(widget->window, cursor);
        gdk_cursor_destroy(cursor);

        return FALSE;
}

gboolean
on_leave_splash_notify_event           (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
        GdkCursor* cursor;
        cursor = gdk_cursor_new(0);
        gdk_window_set_cursor(widget->window, cursor);
        gdk_cursor_destroy(cursor);

        return FALSE;
}

