#include <gtk/gtk.h>
#include <sys/socket.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "state.h"
#include "support.h"
#include "testplan_treeview.h"
#include "testmap.h"
#include "xml_work.h"
#include "pthreads.h"
#include "hw_parser.h"

//int connect_server = 0;

gpointer
pthread_gethwinfo	(gpointer	user_data)
{
	FILE *f_hw;
	gint answer = 1;
	GtkWidget *window, *label_description;
	gint status, rc;
	gchar command[128];
	gchar *out = NULL, hw[64] = "\0";
	gchar first [32] = "\0", second[32] = "\0", email[32] = "\0";
	struct stat buf;

/*
	g_sprintf (command, "/usr/bin/script_find_client %d",getpid ());
	rc = g_spawn_command_line_sync (command, &out, NULL, &status, NULL);
	rc = wait (&status);
	
	if (strlen (out) > 0)
	{
		g_printf ("Only one copy of improver_client can work at one moment\n");
		exit (0);
	}
*/

	if (g_stat ("/var/local/improver_client_hw", &buf) == -1)
	{
		g_sprintf (command, "/usr/bin/script_hw %s",CACHE_DIR);
		rc = g_spawn_command_line_sync (command, &out, NULL, &status, NULL);
		rc = wait (&status);
		sscanf (out, "%s", hw);
		sscanf (out, "%s", user_info.hw);
		f_hw = fopen ("/var/local/improver_client_hw", "w+");
		g_fprintf (f_hw, "%s", out);
		fclose (f_hw);
		g_free (out);	
	}
	else
	{
		read_file ("/var/local/improver_client_hw", hw);
		hw[32] = '\0';
		read_file ("/var/local/improver_client_hw", user_info.hw);
		user_info.hw[32] = '\0';
	}

	window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);

	GTS_testplan = init_tree ();
	GLS_map	     = init_list ();

	global_sockfd = connect_server (server_info);
	user_info.pause = 10;
	if ( global_sockfd != -1)
	{
		status = command_find (global_sockfd, hw, getenv ("LANG"), first, second, email);
		command_close_connection (global_sockfd);
		if (status == 0)
		{
			gdk_threads_enter ();
			impr_sql_user_init (getuid (), &user_info, first, second, email, hw);
			set_state_welcome_reg (first, second, email);
			label_description = do_hypertext ();
			gtk_box_pack_start (GTK_BOX (get_widget ("hbox_description")), label_description, TRUE, TRUE, 2);
			gdk_threads_leave ();

		}
		else
		{
			if (status != -2)
			{
				gdk_threads_enter ();
				set_state_welcome_noreg ();
				label_description = do_hypertext ();
				gtk_box_pack_start (GTK_BOX (get_widget ("hbox_description")), label_description, TRUE, TRUE, 2);
				gdk_threads_leave ();
			}
			else
			{
				goto offline_mode;
			}
		}
	}
	else
	{
offline_mode:
		rc = impr_sql_user_init (getuid (), &user_info, first, second, email, hw);
		printf ("%d\n", rc);
		if (rc)
		{
			server_status = 1;
			if (!g_strcmp0 (user_info.hw, hw))
			{
				gdk_threads_enter ();
				set_state_welcome_reg_offline ();
				label_description = do_hypertext ();
				gtk_box_pack_start (GTK_BOX (get_widget ("hbox_description")), label_description, TRUE, TRUE, 2);
				gdk_threads_leave ();
			}
			else
			{
				goto noregoffline;
			}
		}
		else
		{
noregoffline:
			gdk_threads_enter ();
			set_state_welcome_noreg_offline ();
			gdk_threads_leave ();
		}
	}

	gdk_threads_enter ();
	gtk_widget_destroy (user_data);
	gdk_threads_leave ();
	gdk_threads_enter ();
	gtk_widget_show (window);
	gdk_threads_leave ();
}


gpointer
pthread_registration	(gpointer	user_data)
{
	gint answer = 1;
	gint rc, i, status;
	gchar error_msg[128], name[30], path_hwzip[512], testplan_path[512], command[128], filename[512];
	DIR *dir;
	struct dirent *entry;


	// GET HW INFO ZIP!!!
	g_sprintf (path_hwzip, "%s/%s/hwinfo.zip", g_get_home_dir (), CACHE_DIR);
	g_sprintf (command, "/usr/bin/script_hw_info %s",CACHE_DIR);
	rc = g_spawn_command_line_sync (command, NULL, NULL, &status, NULL);
	rc = wait (&status);
	xml_generators ();

	g_sprintf (command, "/usr/bin/script_hw_info_tar %s",CACHE_DIR);
	rc = g_spawn_command_line_sync (command, NULL, NULL, &status, NULL);
	rc = wait (&status);

	read_form (user_info.name, user_info.second, user_info.email, user_info.comment);

	global_sockfd = connect_server (server_info);
	if (global_sockfd  != -1 )
	{
		answer = command_registr (global_sockfd, path_hwzip, user_info.name, user_info.second, user_info.email, user_info.hw, getenv ("LANG"), user_info.comment);
		if (answer == 0)
		{
			impr_sql_user_add (getuid (), user_info.hw, user_info.name, user_info.second, user_info.email);
			g_sprintf (testplan_path, "%s/%s/new_testplans", g_get_home_dir (), CACHE_DIR);

			command_get_testplan (global_sockfd, testplan_path);
			command_close_connection (global_sockfd);

			dir = opendir (testplan_path);
			while ( (entry = readdir (dir)) != NULL )
			{
				if ( (strcmp (entry->d_name, ".") != 0) && (strcmp (entry->d_name, "..") != 0))
				{

					g_sprintf (filename,"%s/%s", testplan_path, entry->d_name);
					read_xml (filename);
					g_unlink (filename);
				}
			}

			closedir (dir);

			fill_tree (GTS_testplan);
			gdk_threads_enter ();		
			set_state_testplanlist ();
			gdk_threads_leave ();
		}
		else
		{
			g_sprintf (error_msg, _("Problem with database. Please try later."));
			goto registr_error;
		}
	}
	else
	{
		g_sprintf (error_msg, _("Server is offline. Please try later."));
registr_error:
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		set_state_error (error_msg, 0);
		gdk_threads_leave ();
		return;
	}

	gdk_threads_enter ();
	gtk_widget_destroy (user_data);
	gdk_threads_leave ();
}


gpointer
pthread_news	(gpointer	user_data)
{
	gint answer = 1;
	gint rc, i;
	gchar error_msg[128], name[30], testplan_path[512], filename[512];
	gchar buf[512]; 
	DIR *dir;
	struct dirent *entry;

	g_sprintf (testplan_path, "%s/%s/new_testplans", g_get_home_dir (), CACHE_DIR);
	global_sockfd = connect_server (server_info);
	if (global_sockfd != -1)
	{
		command_find (global_sockfd, user_info.hw, getenv ("LANG"), buf, buf, buf);
		command_get_testplan (global_sockfd, testplan_path);
		command_close_connection (global_sockfd);
		copy_bd (1);
		dir = opendir (testplan_path);
		while ( (entry = readdir (dir)) != NULL )
		{
			if ( (strcmp (entry->d_name, ".") != 0) && (strcmp (entry->d_name, "..") != 0))
			{
				g_sprintf (filename,"%s/%s", testplan_path, entry->d_name);
				read_xml (filename);
				g_unlink (filename);
			}
		}
	
		closedir (dir);
		gdk_threads_enter ();
		fill_tree (GTS_testplan);
		set_state_testplanlist ();
		gtk_widget_destroy (user_data);
		gdk_threads_leave ();
	}
	else
	{
		g_sprintf (error_msg, _("Server is offline. Please try later."));
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		server_status = 1;
		set_state_error (error_msg, 0);
		gdk_threads_leave ();
		return;
	}
}


gpointer
pthread_reload (gpointer user_data)
{
	pthread_news (user_data);
}


gpointer 
pthread_import_plan (gpointer user_data)
{
	pthread_data_st *buf;

	buf = user_data;
	gdk_threads_enter ();
	read_xml (buf->text);
	fill_tree (GTS_testplan);
	gtk_widget_destroy (buf->widget);
	gdk_threads_leave ();

	g_free (user_data);
}


void
get_news ()
{
	GtkWidget *spinner;

	spinner = SpinnerWindow (_("Getting updates"));
	g_thread_create (pthread_news, spinner, FALSE, NULL);
}


gpointer
pthread_attach_pause (gpointer	user_data)
{
	GtkWidget *widget;
	time_t result;
	gchar filename[256] = "/0", time_str[128], warning_msg[256] = "\0";
	GdkPixbuf *screenshot;
	GtkWidget *window;

	sleep (user_info.pause);

	gdk_threads_enter ();
	window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
	gtk_window_iconify (GTK_WINDOW (window));
	screenshot = get_screenshot ();
	gtk_window_deiconify (GTK_WINDOW(window));
	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_sprintf (filename, "%s/%s/screenshots/%d_%s.jpeg", g_get_home_dir (), CACHE_DIR, global_question.curnumattachs ++, time_str);
	add_attach (1, filename);
	if (global_question.curnumattachs == (global_question.numattachs + global_question.numscreens))
	{
		g_sprintf (warning_msg, _("Limit of attached files is reached"));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);
	}
	else
	{
		g_sprintf (warning_msg, _("Attached %d files from %d files"), global_question.curnumattachs ,(global_question.numattachs + global_question.numscreens));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));

		gtk_widget_set_tooltip_text (widget, warning_msg);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));

		gtk_widget_set_tooltip_text (widget, warning_msg);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));

		gtk_widget_set_tooltip_text (widget, warning_msg);
	}

	gdk_pixbuf_save (screenshot, filename, "jpeg", NULL,  "quality", "100", NULL);
	gtk_widget_destroy (user_data);
	gdk_threads_leave ();
}


int 
send_attach (gint tpid_, 
	     gint uid_, 
	     gint attachid_, 
	     gchar *filename)
{
	gchar shortname[256], command[256] = "\0", buf[256];
	gint pos = 0, status_command, rc;
	pos = search_last_slash (filename);
	g_sprintf (buf, "%s/%s/screenshots/", g_get_home_dir (), CACHE_DIR);
	if (g_strrstr (filename, buf) != NULL)
	{
		g_sprintf (command, "/usr/bin/script_convert_screenshots %s", filename);
		rc = g_spawn_command_line_sync (command, NULL, NULL, &status_command, NULL);
		rc = wait (&status_command);
	}

	g_sprintf (shortname, "%s", filename + pos);
	filename [pos-1] = '\0';

	command_send_attach (global_sockfd, filename, shortname);
}

gpointer
pthread_send	(gpointer	user_data)
{
	gint answer = 1, status = 1, pos = 0, status_command;
	gint rc, i;
	gchar error_msg[128], name[30], generate_time[128] = "\0", filename[512] = "\0", shortname [256], buffer[4096], command[256] = "\0";

	impr_sql_testplan_edit_send_time (global_testplan.tpid, getuid ());
//	g_sprintf (filename, "/root/.cache/improver_client/reports/cfc80c7269cade8a9de68d7ff8327f0f_2_2011-07-05T12:19:34.xml");
	xml_generate_report (global_testplan.tpid, filename);
	global_sockfd = connect_server (server_info);
	if ( global_sockfd != -1)
	{

		pos = search_last_slash (filename);
		g_sprintf (shortname, "%s", filename + pos);
		filename [pos-1] = '\0';
		status = command_send_report (global_sockfd, filename, shortname);
		if (status == 0)
		{
//			g_sprintf (command, "/usr/bin/script_convert_screenshots %s/%s", g_get_home_dir (), CACHE_DIR);
//			rc = g_spawn_command_line_sync (command, NULL, &status_command, NULL, NULL);
//			rc = wait (&status_command);
			impr_sql_attach_get_list_for_report (global_testplan.tpid, getuid (), send_attach);
			impr_sql_testplan_update_status (global_testplan, "REPORTED");

			if (strlen (global_testplan.wish_file) > 0)
			{
				bzero (shortname, 256);
				pos = search_last_slash (global_testplan.wish_file);
				g_sprintf (shortname, "%s", global_testplan.wish_file + pos);
				g_sprintf (buffer, "%s", global_testplan.wish_file);
				buffer[pos-1] = '\0';
//				global_testplan.wish_file [pos-1] = '\0';
				command_send_attach (global_sockfd, buffer, shortname);
			}

			command_end_operation (global_sockfd);
			command_close_connection (global_sockfd);

			gdk_threads_enter ();
			gtk_widget_destroy (user_data);
			set_state_end ();
			gdk_threads_leave ();
		}
		else
		{
			g_sprintf (error_msg, _("Problem with processing your report. Please try to send it later."));
			goto error_send;
		}
	}
	else
	{
		g_sprintf (error_msg, _("Server is offline. Please try later."));
error_send:		
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		set_state_error (error_msg, 1);
		gdk_threads_leave ();
		return;
	}
}


gpointer
pthread_send_reports	(gpointer	user_data)
{
	gint answer = 1, status = 1, pos = 0;
	gint rc, i, int_tpid_list[1024], status_command;
	gchar error_msg[128], name[30], generate_time[128] = "\0", filename[512] = "\0", shortname [256] = "\0", spinner_text[256] = "\0";
	gchar command[256] = "\0";
	testplan_st tp_local;
	
	for (i = 0; i < 1024; i++)
	{
		int_tpid_list[i] =  -1;
	}

	global_sockfd = connect_server (server_info);
	if (global_sockfd != -1)
	{
		gdk_threads_enter ();
		gtk_widget_set_sensitive (get_widget ("button_send_reports"), FALSE);
		gdk_threads_leave ();

//		g_sprintf (command, "/usr/bin/script_convert_screenshots %s/%s", g_get_home_dir (), CACHE_DIR);
//		rc = g_spawn_command_line_sync (command, NULL, &status_command, NULL, NULL);
//		rc = wait (&status_command);

		rc = impr_sql_testplan_get_list_not_sended (getuid (), int_tpid_list);
		for (i = 0; i < rc; i++)
		{
			impr_sql_testplan_init_struct (int_tpid_list[i], &tp_local);
			bzero (filename, 256);
			impr_sql_testplan_edit_send_time (tp_local.tpid, getuid ());
			xml_generate_report (tp_local.tpid, filename);

			pos = search_last_slash (filename);
			g_sprintf (shortname, "%s", filename + pos);
			filename [pos-1] = '\0';
			g_sprintf (spinner_text, _("Sending report:\n%s"), shortname);
			gdk_threads_enter ();
			gtk_label_set_text (GTK_LABEL (lookup_widget (get_widget ("window1"), "spinner_label")), spinner_text);
			gdk_threads_leave ();
			sleep (1);

			status = command_send_report (global_sockfd, filename, shortname);
			if (status == 0)
			{
				impr_sql_attach_get_list_for_report (tp_local.tpid, getuid (), send_attach);
				impr_sql_testplan_update_status (tp_local, "REPORTED");

				if (strlen (tp_local.wish_file) > 0)
				{
					bzero (shortname, 256);
					pos = search_last_slash (tp_local.wish_file);
					g_sprintf (shortname, "%s", tp_local.wish_file + pos);
					tp_local.wish_file [pos-1] = '\0';
					command_send_attach (global_sockfd, tp_local.wish_file, shortname);	
				}

				gdk_threads_enter ();	
				gtk_label_set_text (GTK_LABEL (lookup_widget (get_widget ("window1"), "spinner_label")), _("Sending done"));
				gdk_threads_leave ();
				sleep (1);
			}
			else
			{
				g_sprintf (spinner_text, _("Problem with report: %s"), shortname);
				gdk_threads_enter ();
				gtk_label_set_text (GTK_LABEL (lookup_widget (get_widget ("window1"), "spinner_label")), spinner_text);
				gdk_threads_leave ();
				sleep (1);
			}
		}
	
		command_end_operation (global_sockfd);
		command_close_connection (global_sockfd);
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		fill_tree (GTS_testplan);
		gtk_widget_set_sensitive (get_widget ("button_send_reports"), TRUE);
		gdk_threads_leave ();
	}
	else
	{
		g_sprintf (error_msg, _("Server is offline. Please try later."));
//error_send:	

	
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		error_dialog (error_msg, GTK_MESSAGE_ERROR);
		gdk_threads_leave ();
		return;
	}
}


