#include <gtk/gtk.h>
#include "support.h"
#include "state.h"
#include "own_callbacks.h"

GtkWidget 
*CreateOwnAnswer (gint ischoosen, gchar *answer)
{
	GtkWidget *hbox;
	GtkWidget *widget;

	hbox = gtk_hbox_new (FALSE, 0);

	if (!g_strcmp0 (global_question.type, "single"))
	{

		widget = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (get_widget ("radiobutton1")), _("Other"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), ischoosen);
		g_signal_connect (G_OBJECT (widget), "clicked", G_CALLBACK (on_radio_check_clicked), NULL);

		GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),widget, "check_own_button");
		

		gtk_box_pack_start (GTK_BOX (hbox), widget, FALSE, TRUE, 2);
		widget = gtk_entry_new ();
		gtk_entry_set_text (GTK_ENTRY (widget), answer);
		g_signal_connect (G_OBJECT (widget), "changed", G_CALLBACK (on_entry_ownanswer_changed), NULL);

		if (ischoosen)
		{
			gtk_widget_set_sensitive (widget, TRUE);
		}
		else
		{
			gtk_widget_set_sensitive (widget, FALSE);
		}

		gtk_box_pack_start (GTK_BOX (hbox), widget, FALSE, TRUE, 2);

		GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),widget, "check_own_entry");
	}
	else
	{
		widget = gtk_check_button_new_with_label (_("Other"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), ischoosen);
		g_signal_connect (G_OBJECT (widget), "toggled", G_CALLBACK (on_radio_check_clicked), NULL);
		

		gtk_box_pack_start (GTK_BOX (hbox), widget, FALSE, TRUE, 2);
		GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),widget, "check_own_button");
		

		widget = gtk_entry_new ();
		gtk_entry_set_text (GTK_ENTRY (widget), answer);
		
		gtk_entry_set_max_length (GTK_ENTRY (widget), 512);
		if (ischoosen)
		{
			gtk_widget_set_sensitive (widget, TRUE);
		}
		else
		{
			gtk_widget_set_sensitive (widget, FALSE);
		}
		gtk_box_pack_start (GTK_BOX (hbox), widget, FALSE, TRUE, 2);
		g_signal_connect (G_OBJECT (widget), "changed", G_CALLBACK (on_entry_ownanswer_changed), NULL);
		GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),widget, "check_own_entry");

	}

	return hbox;	
}


gint
create_raido_form 	(int tpid_, 
 			 int uid_,
			 int qnum_, 
			 char *variant_, 
			 int ischoosen_,
			 int ismyself_,
			 int answer_num_,
			 void *data)
{
	GtkWidget *radio1;
	gchar widget_name[32];

	if (!ismyself_)
	{
		radio1 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (get_widget ("radiobutton1")), variant_);
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radio1), ischoosen_);		

		g_signal_connect (G_OBJECT (radio1), "toggled", G_CALLBACK (on_radio_check_clicked), NULL);
		g_sprintf (widget_name, "radio%d", answer_num_);

//		if (answer_num_%2 == 0)
//		{
			gtk_box_pack_start (GTK_BOX (get_widget ("vbox_left")), radio1, FALSE, TRUE, 2);
			gtk_widget_show (radio1);
			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),radio1,widget_name);
//		}
//		else
//		{
//			gtk_box_pack_start (get_widget ("vbox_right"), radio1, FALSE, TRUE, 2);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),radio1,widget_name);
//			gtk_widget_show (radio1);
//		}
	}
	else
	{
//		if (answer_num_%2 == 0)
//		{
			radio1 =  CreateOwnAnswer (ischoosen_, variant_);
			gtk_box_pack_start (GTK_BOX (get_widget ("vbox_left")), radio1, FALSE, TRUE, 2);
			gtk_widget_show_all (radio1);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),radio1, "check_own");
//			gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
//		}
//		else
//		{
//			radio1 =  CreateOwnAnswer (ischoosen_, variant_);
//			gtk_box_pack_start (get_widget ("vbox_right"), radio1, FALSE, TRUE, 2);
//			gtk_widget_show_all (radio1);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),radio1, "check_own");
//			gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
//		}
	}
	
	return 0;
}


gint
delete_raido_form	(int tpid_,
		 	 int uid_, 
			 int qnum_,
			 char *variant_,
			 int ischoosen_,
			 int ismyself_,
			 int answer_num_,
			 void *data)
{
	GtkWidget *radio1, *widget = NULL;
	gchar widget_name[32];

	if (!ismyself_)
	{
		g_sprintf (widget_name, "radio%d", answer_num_);
		widget = lookup_widget (get_widget ("window1"), widget_name);
		if (widget != NULL)
		{
			gtk_widget_destroy (widget);
		}
	}
	else
	{
		widget = lookup_widget (get_widget ("window1"), "myselft_button");
		if (widget != NULL)
		{
			gtk_widget_destroy (widget);
		}
	}
	
	return 0;
}


gint
create_check_form	(int tpid_,
			 int uid_,
			 int qnum_,
			 char *variant_,
			 int ischoosen_,
			 int ismyself_,
			 int answer_num_,
			 void *data)
{
	GtkWidget *check1;
	gchar widget_name[32];

	if (!ismyself_)
	{
		check1 = gtk_check_button_new_with_label (variant_);
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (check1), ischoosen_);
		g_signal_connect (G_OBJECT (check1), "toggled", G_CALLBACK (on_radio_check_clicked), NULL);
		
		g_sprintf (widget_name, "check%d", answer_num_);

//		if (answer_num_%2 == 0)
//		{
			gtk_box_pack_start (GTK_BOX (get_widget ("vbox_left")), check1, FALSE, TRUE, 2);
			gtk_widget_show (check1);
			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),check1,widget_name);
//		}
//		else
//		{
//			gtk_box_pack_start (get_widget ("vbox_right"), check1, FALSE, TRUE, 2);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),check1,widget_name);
//			gtk_widget_show (check1);
//		}
	}
	else
	{
//		if (answer_num_%2 == 0)
//		{
			check1 =  CreateOwnAnswer (ischoosen_, variant_);
			gtk_box_pack_start (GTK_BOX (get_widget ("vbox_left")), check1, FALSE, TRUE, 2);
//			gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
			gtk_widget_show_all (check1);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),check1, "check_own");
//		}
//		else
//		{
//			check1 =  CreateOwnAnswer (ischoosen_, variant_);
//			gtk_box_pack_start (get_widget ("vbox_right"), check1, FALSE, TRUE, 2);

//			gtk_widget_set_sensitive (lookup_widget (get_widget ("window1"), "check_own_entry"), FALSE);
//			gtk_widget_show_all (check1);
//			GLADE_HOOKUP_OBJECT(GTK_WIDGET (get_widget ("window1")),check1, "check_own");
//		}
	}
	
	return 0;
}


gint
delete_check_form	(int tpid_,
			 int uid_,
			 int qnum_,
			 char *variant_,
			 int ischoosen_,
			 int ismyself_,
			 int answer_num_)
{
	GtkWidget *widget = NULL;
	gchar widget_name[32];

	if (!ismyself_)
	{
		g_sprintf (widget_name, "check%d", answer_num_);
		widget = lookup_widget (get_widget ("window1"), widget_name);
		if (widget != NULL)
		{
			gtk_widget_destroy (widget);
		}
	}
	else
	{
		widget = lookup_widget (get_widget ("window1"), "myselft_button");
		if (widget != NULL)
		{
			gtk_widget_destroy (widget);
		}
	}
	
	return 0;
}


void
draw_answers ()
{
	if (!g_strcmp0 (global_question.type, "single"))
	{
		global_question.numanswers = impr_sql_answer_get_list (global_testplan.tpid, getuid (), global_testplan.curquestion, create_raido_form, NULL);
	}
	else
	{
/*
		MULTI
*/
		global_question.numanswers = impr_sql_answer_get_list (global_testplan.tpid, getuid (), global_testplan.curquestion, create_check_form, NULL);
	}
}


void
for_each_vbox_destroy (GtkWidget *child, gpointer data)
{
	gtk_widget_destroy (child);
}


void
clear_answers ()
{
	gtk_container_forall (GTK_CONTAINER (get_widget ("vbox_left")), for_each_vbox_destroy, NULL);
	gtk_container_forall (GTK_CONTAINER (get_widget ("vbox_right")), for_each_vbox_destroy, NULL);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (get_widget ("radiobutton1")), TRUE);
}


void
set_state_welcome_reg	(gchar *first, 
			 gchar *second,
			 gchar *email)
{
	gchar text [256] = "\0";
	GdkColor color;

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_REGOK);

	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), _("Improver: ready to work"));
	
	gdk_colormap_alloc_color            (gdk_colormap_get_system  (), &color, TRUE, TRUE);
	gdk_color_parse  ("#025488", &color);
	gtk_widget_modify_bg (GET_WIDGET ("vbox_header"), GTK_STATE_NORMAL, &color);

	g_sprintf (text, _("First name	%s"), first);
	gtk_label_set_text (GTK_LABEL (get_widget ("label_name")), text);

	g_sprintf (text, _("Last name	%s"), second);
	gtk_label_set_text (GTK_LABEL (get_widget ("label_second_name")), text);

	g_sprintf (text, _("Email	%s"), email);
	gtk_label_set_text (GTK_LABEL (get_widget ("label_email")), text);

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_next"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));
	gtk_widget_hide (GET_WIDGET ("button_finish"));

	current_state = STATE_REGOK;
}


void
set_state_welcome_noreg ()
{
	GdkColor color;

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_REGNO);

	gdk_colormap_alloc_color            (gdk_colormap_get_system  (), &color, TRUE, TRUE);
	gdk_color_parse  ("#025488", &color);
	gtk_widget_modify_bg (GET_WIDGET ("vbox_header"), GTK_STATE_NORMAL, &color);

	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), _("Improver: please register"));

	gtk_widget_set_sensitive (get_widget ("button_next"), FALSE);

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_full_testplan_list"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));
	gtk_widget_hide (GET_WIDGET ("button_finish"));

	current_state = STATE_REGNO;
}


void
set_state_welcome_reg_offline ()
{
	GdkColor color;

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_REGOKOFFLINE);
	gdk_colormap_alloc_color            (gdk_colormap_get_system  (), &color, TRUE, TRUE);
	gdk_color_parse  ("#025488", &color);
	gtk_widget_modify_bg (GET_WIDGET ("vbox_header"), GTK_STATE_NORMAL, &color);

	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), _("Improver: work in autonomous mode"));

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_next"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));
	gtk_widget_hide (GET_WIDGET ("button_finish"));

	current_state = STATE_REGOKOFFLINE;
}


void
set_state_welcome_noreg_offline ()
{
	GdkColor color;

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_ERROR);

	gdk_colormap_alloc_color            (gdk_colormap_get_system  (), &color, TRUE, TRUE);
	gdk_color_parse  ("#025488", &color);
	gtk_widget_modify_bg (GET_WIDGET ("vbox_header"), GTK_STATE_NORMAL, &color);

	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), _("Error"));
	gtk_label_set_text (GTK_LABEL (get_widget ("label_error")), _("We are sorry our servers are offline, and you are not registered. And you can not work in autonomous mode.\nPlease try again later."));

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_full_testplan_list"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));
	gtk_widget_hide (GET_WIDGET ("button_next"));

	current_state = STATE_ERROR;
}


void
set_state_testplanlist ()
{
	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_TESTLIST);

	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), _("Improver: test plans list"));
	gtk_widget_hide (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_set_sensitive (GET_WIDGET ("button_start"), FALSE);
	gtk_widget_set_sensitive (GET_WIDGET ("button_map"), FALSE);

	if (current_state < 4)
	{
		gtk_widget_hide (GET_WIDGET ("button_reload"));
	}

	current_state = STATE_TESTLIST;
}


void
set_state_testdescr ()
{
	gchar title[4096];

	g_sprintf (title, _("Imporver: description of test plan \"%s\""), global_testplan.name);
	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), title);
	set_description_text (global_testplan.description);
	gtk_widget_show_all (GET_WIDGET ("hbox_description"));
	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_TESTDESCR);
//	gtk_label_set_text (GTK_LABEL (get_widget ("label_testplan_description")), global_testplan.description);
	current_state = STATE_TESTDESCR;	

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_set_sensitive (GET_WIDGET ("button_next"), TRUE);
	gtk_widget_hide (GET_WIDGET ("button_finish"));
	gtk_widget_hide (GET_WIDGET ("button_map"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));

}


void 
clear_attachs ()
{
	destroy_attach_widgets		 ();
}


int
add_attach_gui	(gint tpid_,
		 gint uid_,
		 gint qnum_,
		 gint attachid_,
		 gchar *fullpath_,
		 gpointer data)
{
	add_attach (0, fullpath_);
}


void
draw_attachs ()
{
	impr_sql_attach_get_list (global_testplan.tpid, getuid (), global_question.qnum, add_attach_gui, NULL);
}


void
set_state_test ()
{
	gchar title[4096] = "\0", text[128] = "\0", warning_msg[128] = "\0";
	GtkTextBuffer *text_buffer, *buffer;
	GtkTextIter iter_start, iter_end;
	GtkWidget *widget;

	g_sprintf (title, _("Improver: work with test plan \"%s\""), global_testplan.name);
	gtk_window_set_title    (GTK_WINDOW (get_widget ("window1")), title);

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_TEST);

	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_show (GET_WIDGET ("button_finish"));

	impr_sql_question_init_struct (global_testplan.tpid, getuid (), global_testplan.curquestion, &global_question);


	global_question.hascomment = 1;

	g_sprintf (text, _("<b>Question %d from %d</b>"), global_question.qnum, global_testplan.questionnum);
	gtk_label_set_markup (GTK_LABEL (get_widget ("label_qnum")), text);

	text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (get_widget ("textview_qdescr")));
	gtk_text_buffer_set_text (text_buffer, global_question.description, strlen (global_question.description));

	clear_answers ();
	draw_answers ();

	if (global_question.hascomment)
	{

		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (get_widget ("textview_comment")));
		if (strlen (global_question.comment) > 0)
		{
			gtk_text_buffer_set_text (buffer, g_locale_to_utf8(global_question.comment, -1, NULL, NULL, NULL), -1);
		}
		else
		{
			gtk_text_buffer_get_start_iter (buffer, &iter_start);
			gtk_text_buffer_get_end_iter  (buffer, &iter_end);
			gtk_text_buffer_delete (buffer,&iter_start, &iter_end);
		}
		gtk_widget_show (GET_WIDGET ("textview_comment"));
	}
	else
	{
		gtk_widget_hide (GET_WIDGET ("textview_comment"));
	}

	if (global_question.answered)
	{
		gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/green.png");
		gtk_widget_set_sensitive (GET_WIDGET ("textview_comment"), TRUE);
	}
	else
	{
		gtk_image_set_from_file (GTK_IMAGE (get_widget ("image_question_status")), "/usr/share/improver_client/pixmaps/red.png");
		gtk_widget_set_sensitive (GET_WIDGET ("textview_comment"), FALSE);
	}

	gtk_widget_show (GET_WIDGET ("button_finish"));
	if (global_testplan.questionnumdone == global_testplan.questionnum)
	{
			gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), TRUE);
	}
	else
	{
			gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), FALSE);
	}

	if (!g_strcmp0 (global_question.attach, "true"))
	{
		gtk_widget_show (GET_WIDGET ("button_attach_any"));
	}
	else
	{
		gtk_widget_hide (GET_WIDGET ("button_attach_any"));

	}

	if (global_question.curnumattachs == (global_question.numattachs + global_question.numscreens))
	{
		g_sprintf (warning_msg, _("Limit of attached files is reached"));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));
		gtk_widget_set_sensitive (widget, FALSE);
		gtk_widget_set_tooltip_text (widget, warning_msg);
	}
	else
	{
		g_sprintf (warning_msg, _("Attached %d files from %d files"), global_question.curnumattachs, (global_question.numattachs + global_question.numscreens));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));
		gtk_widget_set_sensitive (widget, TRUE);

		gtk_widget_set_tooltip_text (widget, warning_msg);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));
		gtk_widget_set_sensitive (widget, TRUE);

		gtk_widget_set_tooltip_text (widget, warning_msg);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));
		gtk_widget_set_sensitive (widget, TRUE);
		gtk_widget_set_tooltip_text (widget, warning_msg);
	}
		
	// CLEAR ATTACHS
	clear_attachs ();
	draw_attachs ();

	if (global_testplan.curquestion == 1)
	{
		gtk_widget_set_sensitive (GET_WIDGET ("button_prev"), FALSE);
		gtk_widget_set_sensitive (GET_WIDGET ("button_next"), TRUE);
	}
	else
	{
		if (global_testplan.curquestion == global_testplan.questionnum)
		{
			gtk_widget_set_sensitive (GET_WIDGET ("button_next"), FALSE);
			gtk_widget_set_sensitive (GET_WIDGET ("button_prev"), TRUE);
		}
		else
		{
			gtk_widget_set_sensitive (GET_WIDGET ("button_next"), TRUE);
			gtk_widget_set_sensitive (GET_WIDGET ("button_prev"), TRUE);
		}
	}

	current_state = STATE_TEST;
}


void
set_state_error (gchar *text, gint send)
{
	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_ERROR);

	gtk_label_set_text (GTK_LABEL (get_widget ("label_error")), text);

	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_show (GET_WIDGET ("button_finish"));
	gtk_widget_set_tooltip_text (GET_WIDGET ("button_finish"), " ");
	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_next"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));


	if (send)
	{
		gtk_widget_show (GET_WIDGET ("button_full_testplan_list"));
	}
	else
	{
		if (!server_status)
		{
			gtk_widget_hide (GET_WIDGET ("button_full_testplan_list"));
		}
		else
		{
			gtk_widget_show_all (GET_WIDGET ("button_full_testplan_list"));
		}
	}
	gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), TRUE);
}


void
set_state_send ()
{
	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_SEND);

	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_full_testplan_list"));
	gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), FALSE);
	gtk_widget_set_sensitive (GET_WIDGET ("button_next"), FALSE);	
	gtk_widget_set_sensitive (GET_WIDGET ("button_prev"), TRUE);
	gtk_widget_hide (GET_WIDGET ("button_finish"));
	current_state = STATE_SEND;
}


void
set_state_addon ()
{

	GtkTextBuffer *text_buffer;

	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_ADDON);

	text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (get_widget ("textview_wish")));
	gtk_text_buffer_set_text (GTK_TEXT_BUFFER (text_buffer), g_locale_to_utf8(global_testplan.wish_text, -1, NULL, NULL, NULL), -1);

	if (strlen (global_testplan.wish_file) > 0)
	{
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (get_widget ("togglebutton1")), TRUE);
		gtk_entry_set_text (GTK_ENTRY (get_widget ("entry_wish_name")), global_testplan.wish_file);
	}
	else
	{
		gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (get_widget ("togglebutton1")), FALSE);
		gtk_entry_set_text (GTK_ENTRY (get_widget ("entry_wish_name")), "");
	}

	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_hide (GET_WIDGET ("button_full_testplan_list"));
	gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), FALSE);
	gtk_widget_set_sensitive (GET_WIDGET ("button_next"), TRUE);
	gtk_widget_set_sensitive (GET_WIDGET ("button_prev"), TRUE);
	gtk_widget_hide (GET_WIDGET ("button_finish"));

	current_state = STATE_ADDON;
}


void
set_state_end ()
{
	gtk_notebook_set_current_page (GTK_NOTEBOOK (get_widget ("notebook1")), STATE_END);

	gtk_label_set_text (GTK_LABEL (get_widget ("label_end")), _("Sending report is finished. Confirmation will be send to your e-mail."));
	gtk_widget_show_all (GET_WIDGET ("hbuttonbox_wizard"));
	gtk_widget_hide (GET_WIDGET ("hbuttonbox_testplans_list"));
	gtk_widget_show (GET_WIDGET ("button_full_testplan_list"));
	gtk_widget_set_sensitive (GET_WIDGET ("button_finish"), TRUE);
	gtk_widget_hide (GET_WIDGET ("button_next"));
	gtk_widget_hide (GET_WIDGET ("button_prev"));

	gtk_widget_hide (GET_WIDGET ("button_finish"));

	current_state = STATE_END;
}

